﻿Type=Class
Version=3.82
B4A=true
@EndOfDesignText@
'Class module
#Event: ItemClick(Position As Int, Value As String)
#event: TextChanged(Old As String, New As String)
#Event: ItemLongClick(Position As Int, Value As String)

Private Sub Class_Globals
	
	Private  ComboPnl As Panel
	Private DropLst As List
	Private ImgLst As List
	Private DropLV As ListView
	Private vActivity As Activity
	Private vModule As Object
	Private vParent As Panel
	Private vHeight As Int
	Private vBottom As Int
	Private vDropTXTsize As Int
	Private cColor As Int
	Private cLeft As Int
	Private cTop As Int
	Private cWidth As Int
	Private cHeight As Int
	Private comboedit As EditText
	Private mEvent As String
	Private combobtn As Label
	Private vDefWidth As Int
	Private vEvent As String
	Private vDropColor As Int
	Private vDropTxtColor As Int
	Private first As Boolean = True
	Private RO As Boolean = True
	
End Sub

'Initializes the object. 
'Parent - The calling Activity. 
'Caller - Module name. Must be Me
'Parent - The parent panel. Pass null if the combobox is not being added to a panel.
'Event - Name of your ItemSelected(Position as Int, Value as String) event. Use "" if no event is needed.
'
'Example:
'cb.Initialize(Activity, Me, Null, "cb")
Public Sub Initialize(Owner As Activity, Module As Object, Parent As View, Event As String)
	Dim tp As Panel
	
	vActivity = Owner
	vModule = Module
	
	If Parent.IsInitialized Then
	vParent = Parent
	End If
	
'	If Parent.IsInitialized AND  Parent Is Panel Then
'	tp = Parent
'	vHeight = tp.Height
'	Else
	vHeight = vActivity.Height
'	End If
	
	vBottom = 41dip
	cLeft = 0
	cTop = 0
	cHeight = 40dip
	cWidth = 120dip
		
	mEvent = Event
	vEvent = Event & "_ItemClick"
	DropLst.Initialize
	ImgLst.Initialize
	
	ComboPnl.Initialize("")
	ComboPnl.Color = Colors.Black
	
	vBottom = cTop + cHeight
	
	comboedit.Initialize("comboedit")
	comboedit.TextColor = Colors.Black
	comboedit.Color = Colors.white
	comboedit.TextSize = 14
	comboedit.Gravity = Gravity.CENTER_VERTICAL
	comboedit.Hint = "Tap the Dropdown button for list"
	comboedit.Enabled = False
	
	combobtn.Initialize("Combo")
	combobtn.TextSize = 18
	combobtn.Gravity = Gravity.CENTER
	combobtn.Typeface = Typeface.DEFAULT_BOLD
	combobtn.TextColor = Colors.Black
	combobtn.Color = Colors.RGB(201,148,100)
	combobtn.Text = "V"
	
	ComboPnl.AddView(comboedit,1dip,1dip,cWidth - 32dip, cHeight-2dip)
	ComboPnl.AddView(combobtn,cWidth - 30dip,1dip,30dip,cHeight-2dip)
	vDefWidth = comboedit.Width
	combobtn.Width = 30dip
	
	DropLV.Initialize("Drop")
	ComboPnl.AddView(DropLV, 0,0,18dip, 48dip)
	
	DropLV.SetLayout(0,vBottom,vDefWidth - 2dip, cHeight)
	
	cColor = Colors.RGB(201,148,100)
	
	vDropColor = cColor
	vDropTxtColor = Colors.Black
	DropLV.ScrollingBackgroundColor = Colors.Transparent
	
	DropLV.TwoLinesAndBitmap.ItemHeight = 50dip
	DropLV.TwoLinesAndBitmap.Label.Height = 50dip
	DropLV.TwoLinesAndBitmap.Label.TextColor = vDropTxtColor
	DropLV.TwoLinesAndBitmap.Label.TextSize = 16
	DropLV.TwoLinesAndBitmap.SecondLabel.Visible = False
	DropLV.TwoLinesAndBitmap.SecondLabel.TextSize = 1
	DropLV.TwoLinesAndBitmap.Label.Gravity = Gravity.CENTER_VERTICAL
	
	DropLV.SingleLineLayout.ItemHeight = 50dip
	DropLV.SinglelineLayout.Label.Height = 50dip
	DropLV.SinglelineLayout.Label.TextColor = vDropTxtColor
	DropLV.SinglelineLayout.Label.TextSize = 16
	DropLV.Color = vDropColor
	
	DropLV.SinglelineLayout.Label.Gravity = Gravity.CENTER_VERTICAL
	
	vDropTXTsize = 16
	DropLV.Visible = False
	
End Sub

'Pass this to the AddView call of the Activity or Panel after you initialize the combobox.
'
'Example:
'cb.Initialize(Activity, Me, Panel1, "cb")
'Panel1.AddView(cb.AsView,0 ,0, 150dip, 40dip)
Public Sub AsView As Panel
	
	Return ComboPnl
	
End Sub

'Get or Set the text box as read only or editable
'Pass True for read only mode or False if the user can enter a value not in the Dropdown list
'ReadOnly = False allows the user to add text without selecting from the dropdown list
Public Sub setReadOnly(Read As Boolean)
	
	RO = Read
	
	comboedit.Enabled = Not(RO)
	
End Sub

'Get or Set the text box as read only or editable
'Pass True for read only mode or False if the user can enter a value not in the Dropdown list
Public Sub getReadOnly As Boolean
	
	Return RO
	
End Sub

'Gets or sets the left position of the combobox.
Public Sub getLeft As Int
	
	Return cLeft
	
End Sub

'Sets the Left position of the combobox.
Public Sub setLeft(Pos As Int)
	
	ComboPnl.Left = Pos
	cLeft = Pos
	DropLV.Left = 0
	DoEvents
	
End Sub

'Gets or sets the Top position of the combobox.
Public Sub getTop As Int
	
	Return cTop
	
End Sub

'Sets the width of the drop down button. Default width is 30dip.
'The button height is the same as the component Height - 2Dip.
Sub setButtonWidth(newWidth As Int)
	Dim oldwidth, dif As Int
	Dim smaller As Boolean
	
	smaller = False
	oldwidth = combobtn.width
	
	combobtn.Width = newWidth
	dif = newWidth - oldwidth
	
	If dif < 0 Then
	dif = oldwidth - newWidth
	smaller = True
	End If
	
	If smaller Then
	combobtn.Left = combobtn.Left + dif
	comboedit.Width = comboedit.Width + dif
	Else
	combobtn.Left = combobtn.Left - dif
	comboedit.Width = comboedit.Width - dif
	End If
	
	DoEvents
	
End Sub

'Sets the Top position.
Public Sub setTop(Pos As Int)
	
	ComboPnl.Top = Pos
	cTop = Pos
	vBottom = cTop + comboedit.Height
	
	DropLV.Top = cHeight + 1dip
	
End Sub

'Gets or sets the Width.
Public Sub getWidth As Int
	
	Return cWidth
	
End Sub

'Sets the hint displayed if the combo text is empty. 
'Default is Touch to display list.
Sub setHint(Txt As String)
	
	comboedit.Hint = Txt
	
End Sub

'Sets the Width.
Public Sub setWidth(Pos As Int)
	
	cWidth = Pos
	ComboPnl.Width = Pos
	comboedit.Width = Pos - 32dip
	combobtn.Left = Pos - 30dip
	
	DropLV.Width = Pos - 1dip
	
End Sub

'Gets or sets the Height.
Public Sub getHeight As Int
	
	Return cHeight
	
End Sub

'Sets the Height.
Public Sub setHeight(Pos As Int)
	
	cHeight = Pos
	ComboPnl.Height = Pos
	comboedit.Height = Pos - 1dip
	combobtn.Height = Pos - 1dip
	
	vBottom = cTop + cHeight
	
	DropLV.Top = cHeight + 1dip
	
End Sub

'Changes the Line color of Borders and lines between items
Public Sub LineColor(newColor As Int)
	
	ComboPnl.Color = newColor
	
End Sub

'Changes the button foreground and background colors.
Public Sub ButtonColor(fgColor As Int, bgColor As Int)
	
	combobtn.Color = bgColor
	combobtn.TextColor = fgColor
	DoEvents
	
End Sub

'Sets a bitmap to the button. 
'The default V will NOT be visible
'The Button Is 30dip wide by Height tall, and will fill the Button centered.
Public Sub ButtonIcon(Bmp As BitmapDrawable)
	
	combobtn.Background = Bmp
	combobtn.Text = ""
	DoEvents
	
End Sub

'Returns the text at Position number given
Public Sub GetItem(Position As Int) As String
	
	Return DropLst.get(Position)
	
End Sub

'Returns the position number of the text item given in Txt.
Public Sub IndexOf(Txt As String) As Int
	Dim t As Int
	
	t =  DropLst.IndexOf(Txt)
	
	Return t
	
End Sub

'Returns the number of items in the dropdown list.
Public Sub Size As Int
	
	Return DropLst.Size
	
End Sub

'Gets or sets the value of the combo box.
Public Sub getText As String
	
	Return comboedit.Text
	
End Sub

Public Sub setText(Txt As String)
	
	comboedit.Text = Txt
	
End Sub

'Sets the item to show in the combobox.
Public Sub setDefault(Position As Int)
	
	comboedit.Text = DropLV.GetItem(Position)
	DoEvents
	
End Sub

' Sets the color of the combobox
Public Sub Color(bgColor As Int)
	
	comboedit.Color = bgColor
	
End Sub

'Sets the text color of the combobox.
Public Sub TXTcolor(TextColor As Int)
	
	comboedit.TextColor = TextColor
	
End Sub

'Sets the text size of the combobox.
Public Sub TXTsize(TextSize As Int)
	
	comboedit.TextSize = TextSize
	combobtn.TextSize = TextSize
	
	DoEvents
	
End Sub

'Adds an item to the dropdown list. With or without a bitmap.
'Item -  the text to add
'Img - The bitmap to add. Pass Null for no bitmap.
Public Sub AddItem(Item As String, Img As Bitmap)
	
	If Img.IsInitialized Then
	DropLV.AddTwoLinesAndBitmap(Item, "", Img)
	DropLV.TwoLinesAndBitmap.ImageView.Width = 50dip
	DropLV.TwoLinesAndBitmap.Label.Left = 52dip
	DropLV.TwoLinesAndBitmap.ImageView.Gravity = Gravity.CENTER
	
	DropLV.Color = vDropColor
	DropLV.TwoLinesAndBitmap.Label.TextColor = vDropTxtColor
	DropLV.TwoLinesAndBitmap.Label.TextSize = vDropTXTsize
	
	DropLst.Add(Item)
	ImgLst.Add(Img)
	Else
	DropLV.AddSingleLine(Item)
	DropLV.SingleLineLayout.Label.Left = 2dip
	
	DropLV.Color = vDropColor
	DropLV.SingleLineLayout.Label.TextColor = vDropTxtColor
	DropLV.SingleLineLayout.Label.TextSize = vDropTXTsize
	
	DropLst.Add(Item)
	ImgLst.Add(Null)
	End If
	
	DropLV.TwoLinesAndBitmap.SecondLabel.Visible = False
	
	DropLV.Height = DropLV.Size * 50dip
	DropLV.Top =  cHeight + 1dip
	DropLV.Left = 0
	
	DoEvents
	
End Sub

'Adds an item to the dropdown list at a specified position.
'Position - the position to insert the item. Must be 0 to Size - 1
'Item -  the text to add
'Img - The bitmap to add. Pass Null for no bitmap.
Public Sub AddItemAt(Position As Int, Item As String, Img As Bitmap)
	Dim a  As Int
	Dim image As Bitmap
	
	
	If (Position > DropLst.Size - 1) OR (Position < 0) Then
	Return
	End If
	
	DropLst.InsertAt(Position, Item)
	If Img.IsInitialized Then
	ImgLst.InsertAt(Position, Img)
	Else
	ImgLst.InsertAt(Position, Null)
	End If
	
	DropLV.Clear
	
	For a = 0 To Position
	image = ImgLst.Get(a)
	
	If image.IsInitialized Then
	DropLV.AddTwoLinesAndBitmap(DropLst.Get(a), "", image)
	DropLV.TwoLinesAndBitmap.ImageView.Width = 50dip
	DropLV.TwoLinesAndBitmap.Label.Left = 52dip
	DropLV.TwoLinesAndBitmap.ImageView.Gravity = Gravity.CENTER
	
	DropLV.Color = vDropColor
	DropLV.TwoLinesAndBitmap.Label.TextColor = vDropTxtColor
	DropLV.TwoLinesAndBitmap.Label.TextSize = vDropTXTsize
	Else
	DropLV.AddSingleLine(DropLst.get(a))
	DropLV.SingleLineLayout.Label.Left = 2dip
	
	DropLV.Color = vDropColor
	DropLV.SingleLineLayout.Label.TextColor = vDropTxtColor
	DropLV.SingleLineLayout.Label.TextSize = vDropTXTsize
	End If
	
	Next
	
	If Img.IsInitialized Then
	DropLV.AddTwoLinesAndBitmap(Item, "", Img)
	DropLV.TwoLinesAndBitmap.ImageView.Width = 50dip
	DropLV.TwoLinesAndBitmap.Label.Left = 52dip
	DropLV.TwoLinesAndBitmap.ImageView.Gravity = Gravity.CENTER
	
	DropLV.Color = vDropColor
	DropLV.TwoLinesAndBitmap.Label.TextColor = vDropTxtColor
	DropLV.TwoLinesAndBitmap.Label.TextSize = vDropTXTsize
	Else
	DropLV.AddSingleLine(Item)
	DropLV.SingleLineLayout.Label.Left = 2dip
	
	DropLV.Color = vDropColor
	DropLV.SingleLineLayout.Label.TextColor = vDropTxtColor
	DropLV.SingleLineLayout.Label.TextSize = vDropTXTsize
	End If
	
	For a = Position + 1 To DropLst.Size - 1
	image = ImgLst.Get(a)
	
	If image.IsInitialized Then
	DropLV.AddTwoLinesAndBitmap(DropLst.Get(a), "", image)
	DropLV.TwoLinesAndBitmap.ImageView.Width = 50dip
	DropLV.TwoLinesAndBitmap.Label.Left = 52dip
	DropLV.TwoLinesAndBitmap.ImageView.Gravity = Gravity.CENTER
	
	DropLV.Color = vDropColor
	DropLV.TwoLinesAndBitmap.Label.TextColor = vDropTxtColor
	DropLV.TwoLinesAndBitmap.Label.TextSize = vDropTXTsize
	
	Else
	DropLV.AddSingleLine(DropLst.get(a))
	DropLV.SingleLineLayout.Label.Left = 2dip
	
	DropLV.Color = vDropColor
	DropLV.SingleLineLayout.Label.TextColor = vDropTxtColor
	DropLV.SingleLineLayout.Label.TextSize = vDropTXTsize
	End If
	
	Next
	
	DropLV.Height = DropLV.Size * 50dip
	DropLV.Top = cHeight + 1dip
	DropLV.Left = 0
	
	DoEvents
		
End Sub

'Removes an item from the dropdown list at a specified position.
Public Sub RemoveItemAt(Position As Int) As Boolean
	
	
	DropLst.RemoveAt(Position)
	ImgLst.RemoveAt(Position)
	
	DropLV.RemoveAt(Position)
	
	DropLV.Height = DropLV.Height - 50dip
	DropLV.Top = cHeight + 1dip
	DropLV.Left = 0
	
	DoEvents
	Return True
	
End Sub

'Clears all entries of the combobox and dropdown list.
Public Sub Clear
	
	DropLV.Clear
	DropLst.Clear
	ImgLst.Clear
	
	comboedit.Text = ""
	
End Sub

'Sets the color of the dropdown list.
Public Sub DropColor(newColor As Int)
	
	vDropColor = newColor
	DropLV.Color = newColor
	DropLV.Invalidate
	DoEvents
	
End Sub

'Sets the text size of the dropdown list.
Public Sub DropTextColor(newColor As Int)
	
	vDropTxtColor = newColor
	DropLV.TwoLinesAndBitmap.Label.TextColor = newColor
	DropLV.SingleLineLayout.Label.TextColor = newColor
	DropLV.Invalidate
	DoEvents
	
End Sub

'Sets the text size of the dropdown list.
Public Sub DropTextSize(newSize As Int)
	
	vDropTXTsize = newSize
	
	DropLV.TwoLinesAndBitmap.Label.TextSize = newSize
	DropLV.SingleLineLayout.Label.TextSize = newSize
	DropLV.Invalidate
	DoEvents
	
End Sub

'Opens the dropdown list. Can be used for Menu key press.
'Self adjusts for the Activity height so the drop down does not go past the bottom of the screen.
'Also resizes itself for long lists.
Public Sub DropOpen
	Dim hgt, top As Int
	
	ComboPnl.BringToFront
	
	If DropLV.Height > vActivity.Height Then
	DropLV.Height = ((vActivity.Height / cHeight) * cHeight)
	Else
	DropLV.Height = DropLV.Height + (DropLV.Size * 1dip)
	End If
	
	top = vActivity.top + ComboPnl.top + ComboPnl.Height
'	top = hgt + DropLV.Height
	
	If top > vHeight Then
	DropLV.top = vHeight - DropLV.Height - 5dip
	Else
	DropLV.top = top
	End If
	
	If first Then
	DropLV.RemoveView
	If vParent.IsInitialized Then
	vActivity.AddView(DropLV, vParent.Left+ComboPnl.Left, vParent.top+DropLV.top, ComboPnl.Width, DropLV.Height)
	Else
	vActivity.AddView(DropLV, ComboPnl.Left, DropLV.top, ComboPnl.Width, DropLV.Height)
	End If
	
	first = False
	End If
	
	DropLV.Visible = True
	DropLV.BringToFront
	
End Sub

'Closes the dropdown list.
Public Sub DropClose
	
	DropLV.Visible = False
	
End Sub

'Returns True if the drop down box is being shown.
Public Sub DropShowing As Boolean
	
	Return DropLV.Visible
	
End Sub

Private Sub Drop_ItemClick (Position As Int, Value As Object)
	
	comboedit.Text = Value
	If DropShowing Then DropClose
	
	If vEvent <> "" Then
	
	If SubExists(vModule, vEvent) Then
	CallSub3(vModule, vEvent.ToLowerCase, Position, Value)
	End If
	
	End If
	
End Sub

Private Sub Drop_ItemLongClick (Position As Int, Value As Object)
	Dim st As String
	
	
	If mEvent <> "" Then
	st = mEvent & "_ItemLongClick"
	
	If SubExists(vModule, st) Then
	CallSub3(vModule, st.ToLowerCase, Position, Value)
	End If
	
	End If
	
End Sub

Private Sub Combo_Click
	
	If DropShowing Then
	DropClose
	Return
	End If
	
	DropOpen
	
End Sub

Sub comboedit_TextChanged (Old As String, New As String)
	Dim st As String
	
	If mEvent <> "" Then 
	
	st = mEvent & "_TextChanged"
	
	If SubExists(vModule, mEvent) Then
	CallSub3(vModule, st.ToLowerCase, Old, New)
	End If
	
	End If
	
End Sub